<?php
/**
* @version $Id: display.php Thu Dec 22 23:06:13 WST 2005 shaynebartlett
* @package J! Whois
* @copyright Copyright (C) 2005 theJ!factory. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* J! Whois is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// NO DIRECT ACCESS
defined( '_VALID_MOS' ) or die( 'Restricted access' );

// Languages
if (file_exists(JF_LANGUAGE . $mosConfig_lang.'.php')) {
  require_once(JF_LANGUAGE . $mosConfig_lang.'.php');
} else {
  require_once(JF_LANGUAGE . 'english.php');	
}

/* ------------------------------------------------------------------ */
//	EP-Dev Whois Admin Display Class
//	Contains all output related functions.
/* ------------------------------------------------------------------ */

class jf_admin_display extends mosHTML 
{

	var $defaults;
	var $MENU;

	/* ------------------------------------------------------------------ */
	//	Our constructor loads up basic stuff / variables needed.
	/* ------------------------------------------------------------------ */

	function jf_admin_display($title)
	{
		$this->defaults['title_text'] = $title;
		$this->MENU = new EP_Dev_Whois_Admin_Menu_Bar();
		$this->load_Default_Menu();
	}


	/* ------------------------------------------------------------------ */
	//	loads default menu
	/* ------------------------------------------------------------------ */
	
	function load_Default_Menu()
	{
		$this->MENU->add("<div class=\"menutitle\" >" . _JF_MAIN_MENU . "</div>", "", 1);
		$this->MENU->add(_JF_MAIN, "index2.php?option=com_jfwhois", 1);
		$this->MENU->add(_JF_SCRIPT_SETTINGS, "index2.php?option=com_jfwhois&amp;task=ScriptSettings", 1);
		$this->MENU->add(_JF_EDIT_TEMPLATES, "index2.php?option=com_jfwhois&amp;task=TemplateSettings", 1);
		$this->MENU->add(_JF_ERROR_SETTINGS, "index2.php?option=com_jfwhois&amp;task=ErrorSettings", 1);

		$this->MENU->add("<div class=\"menutitle\" >" . _JF_NAMESERVER_MENU . "</div>", "", 2);
		$this->MENU->add(_JF_ADD_NAMESERVER, "index2.php?option=com_jfwhois&amp;task=AddNameserver", 2);
		$this->MENU->add(_JF_EDIT_NAMESERVER, "index2.php?option=com_jfwhois&amp;task=NameserverSettings", 2);
		$this->MENU->add(_JF_NAMESERVER_VALIDATOR, "index2.php?option=com_jfwhois&amp;task=NSValidator", 2);

		$this->MENU->add("<div class=\"menutitle\" >" . _JF_ECOMMERCE_MENU . "</div>", "", 3);
		$this->MENU->add(_JF_ECOMMERCE_SETTINGS, "index2.php?option=com_jfwhois&amp;task=BuyModeSettings", 3);
		$this->MENU->add(_JF_EDIT_PRICES, "index2.php?option=com_jfwhois&amp;task=TLDSettings", 3);

		$this->MENU->add("<div class=\"menutitle\" >" . _JF_OTHER_MENU . "</div>", "", 4);
		$this->MENU->add(_JF_HELP, "index2.php?option=com_jfwhois&amp;task=FAQ", 4);
		
		$this->MENU->add("<div class=\"menutitle\" >" . _JF_ABOUT . "</div>", "", 5);
		$this->MENU->add(_JF_FORUM, "http://www.thejfactory.com/component/option,com_smf/amp;Itemid,9/", 5);
		$this->MENU->add(_JF_TRACKER, "http://developer.joomla.org/sf/tracker/do/listArtifacts/projects.wwhostware/tracker.j_whois", 5);
		$this->MENU->add("<br /><div class=\"menutext\" >" . _JF_ABOUT_TEXT. "</div>", "", 5);	}

	/* ------------------------------------------------------------------ */
	//	Displays header.
	/* ------------------------------------------------------------------ */
	
	function show_Header($extra = "")
	{

				// Display extra header
				echo $extra;
					
					?>
<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript">
			function newWindow(url, container, extra)
			{
				var newWin = window.open(url, container, extra);
			}
		</SCRIPT>
<script  type="text/javascript" src="<?php echo $mosConfig_live_site ; ?>'/includes/js/overlib_mini.js"></script>
;
<link rel="stylesheet" href="components/com_jfwhois/jfwhois.css" type="text/css" />
<div align="center">
  <div style="width: 100%;">
    <div style="margin-bottom: 20px;">
      <?
	}
	

	/* ------------------------------------------------------------------ */
	//	Displays footer.
	/* ------------------------------------------------------------------ */
	
	function show_Footer($extra = "")
	{
		// Display $extra first.
		echo $extra;

		?>
    </div>
  </div>
</div>
<?
	}

	
	/* ------------------------------------------------------------------ */
	//	Displays bulk of task.
	/* ------------------------------------------------------------------ */

	function show_Content($content)
	{
		?>
<table class="adminheading">
  <tr>
    <th class="config">
        <?php // Display task title
			echo $this->defaults['title_text'];?>
      </th>
  </tr>
</table>
<div style="width: 100%;">
  <table class="adminform">
    <tr>
      <?php // only display if menu available
			if ($this->MENU->available())
				{ ?>
      <td class="menucolumn">
          <?php // Display Menu
				$this->MENU->show();?>
        </td>
      <?php } // end if menu available?>
      <td valign="top" style="text-align; center;"><div>
          <div class="adminContent">
            <?php echo $content;?>
          </div>
        </div></td>
    </tr>
  </table>
</div>
<?
	}

	
	/* ------------------------------------------------------------------ */
	//	Construct form input in table row
	/* ------------------------------------------------------------------ */
	
	function constructTableVariable($name, $description, $var_type, $var_name, $var_value="", $size=null, $helpcode=null, $extra="")
	{
		
		mosCommonHTML::loadOverlib();
		
		// table within table
		$row .= "<tr>\n<td>\n<table style='width: 100%;'>\n";

		// Construct name/description/help part
		$row .= "<tr>\n<td align='top'><div><strong>{$name}</strong></div>";
		
/*		if (!empty($helpcode))
			$row .= mosToolTip( "$helpcode" );*/

			// Construct variable

		switch($var_type)
		{
			case "text" :
				$row .= "<td align='right'>{$extra}<input type='text' name='{$var_name}' value=\"" . htmlentities($var_value) . "\"" . (!empty($size) ? " size='{$size}'" : "") . " ID='" . str_replace(".", "___", $var_name) . "'>" . mosToolTip( "$description" ) . "</td>\n";
			break;

			case "textarea" :
				$row .= "</tr>\n</table>\n</td>\n</tr>\n<tr>\n<td>\n<table>\n<tr>\n";

				$row .= "<td align='center' valign='top'><div align='left'>{$extra}</div><textarea name='{$var_name}'" 
					. (!empty($size) ? (!empty($size['rows']) ? "rows='" . $size['rows'] . "'" : "")
					. (!empty($size['cols']) ? "cols='" . $size['cols'] . "'" : "") : "")
					." wrap='off' ID='" . str_replace(".", "___", $var_name) . "'>" . htmlentities($var_value) . "</textarea>" . mosToolTip( $description ) . "</td>\n";
			break;

			case "select" :
				$row .= "<td align='right'>{$extra}<select name='{$var_name}' ID='" . str_replace(".", "___", $var_name) . "'>\n";
				foreach($var_value['options'] as $name_of_var => $value_of_var)
				{
					$row .= "<option value='{$value_of_var}'" . ($var_value['selected'] == $name_of_var ? "selected" : "")
					. ">{$name_of_var}</option>\n";
				}
				$row .= "</select>" . mosToolTip( $description ) . "</td>\n";
			break;
		}

		// close row
		$row .= "</tr>\n";

		// close table
		$row .= "</table>\n</td>\n</tr>";

		return $row;
	}


	/* ------------------------------------------------------------------ */
	//	Construct Output of particular format
	/* ------------------------------------------------------------------ */
	
	function constructOutput($output, $indent=0)
	{
		return "<div style='margin-left:{$indent}; font-family: verdana, sans-serif; font-size: 10pt;'>" . $output . "</div>";
	}


	/* ------------------------------------------------------------------ */
	//	Construct start of form
	/* ------------------------------------------------------------------ */
	
	function constructStartForm($task, $name="adminForm", $method="POST", $url=null, $preSubmitAction=null)
	{
		if (!empty($preSubmitAction))
			$preSubmitAction = " onSubmit='" . $preSubmitAction . "'";

		if (empty($url))
			$url = "index2.php?option=com_jfwhois";

		return "<form name='{$name}' id=\"adminForm\" action='{$url}' method='{$method}'{$preSubmitAction}>\n"
				. "<input type='hidden' name='task' value='{$task}'>\n"
				. "<input type='hidden' name='option' value='com_jfwhois'>\n";
	}


	/* ------------------------------------------------------------------ */
	//	Construct end of form with buttons
	/* ------------------------------------------------------------------ */
	
	function constructEndForm($submitButton = "Submit", $resetButton = "")
	{
		if (!empty($submitButton))
			$subBut = "<input type='submit' value='{$submitButton}'>\n";

		if (!empty($resetButton))
			$resBut = "<input type='reset' value='{$resetButton}'>\n";

		return "{$subBut}&nbsp;&nbsp;{$resBut}</form>\n";
	}


	/* ------------------------------------------------------------------ */
	//	Displays task in one easy function so you don't have to call each
	//  function individually. Adds menu if not present.
	/* ------------------------------------------------------------------ */

	function displaytask($content, $title = NULL, $menu = NULL, $header_extra = "", $footer_extra = "")
	{
		// If menu, assign.
		if (!empty($menu))
			$this->MENU = $menu;

		// if title, assign to obj
		if (!empty($title))
			$this->defaults['title_text'] = $title ;

		// Continue to construct task.
		$this->show_Header($header_extra);
		$this->show_Content($content);
		$this->show_Footer($footer_extra);
	}

}


/* ------------------------------------------------------------------ */
//	EP-Dev Whois Admin Menu Class
//	Contains all menu construction and display related functions
/* ------------------------------------------------------------------ */

class EP_Dev_Whois_Admin_Menu_Bar extends mosHTML 
{

	/* ------------------------------------------------------------------ */
	//	Our constructor loads up default stuff.
	/* ------------------------------------------------------------------ */

	function EP_Dev_Whois_Admin_Menu_Bar()
	{
		// nada
	}

	
	/* ------------------------------------------------------------------ */
	//	Add Item to Menu
	/* ------------------------------------------------------------------ */
	
	function add($text, $url = "", $menu_id = 1)
	{
		// Add on text part to MenuData
		$this->MenuData[$menu_id]['item'][count($this->MenuData[$menu_id]['item'])] = $text;

		// Add on url part to MenuData
		$this->MenuData[$menu_id]['url'][count($this->MenuData[$menu_id]['url'])] = $url;
	}


	/* ------------------------------------------------------------------ */
	//	Remove item from menu
	/* ------------------------------------------------------------------ */
	
	function remove($key = false, $text = false, $url = false, $menu_id = 1)
	{

		// Check if searching by text
		if ($text)
		{
			$key = array_search($text, $this->MenuData[$menu_id]['item']);
		}

		// Check if searching by url
		if ($url)
		{
			$key = array_search($url, $this->MenuData[$menu_id]['url']);
		}

		// remove key
		if ($key !== false)
		{
			unset($this->MenuData[$menu_id]['item'][$key]);
			unset($this->MenuData[$menu_id]['url'][$key]);
		}

	}

	
	/* ------------------------------------------------------------------ */
	//	Remove all menus
	/* ------------------------------------------------------------------ */
	
	function remove_all()
	{
		// Remove all menus
		unset($this->MenuData);
	}


	/* ------------------------------------------------------------------ */
	//	Display Menu
	/* ------------------------------------------------------------------ */
	
	function show($menu_id = 0)
	{
		if ($this->available())
		{
			// Do a loop to display either all ids (if menu_id = 0), or one id ($menu_id).
			for ($i = ($menu_id ? $menu_id : 1); $i < ($menu_id ? ($menu_id + 1) : (count($this->MenuData)+1)); $i++)
			{
					
				// Cycle through all entries for this menu.
				for ($j=0; $j < count($this->MenuData[$i]['item']); $j++)
				{
				
					// If a url for item exists, then make item a link
					if (!empty($this->MenuData[$i]['url'][$j]))
					{
						echo "<a class=\"menuitem\" href=\"".$this->MenuData[$i]['url'][$j]."\">".$this->MenuData[$i]['item'][$j]."</a>";
					}

					// Else make it a Menu Header / Category
					else
					{
						echo $this->MenuData[$i]['item'][$j];
					}

					echo "<br>";
				}
			
				?>
<br>
<?php

			}
		}
	}


	/* ------------------------------------------------------------------ */
	//	Create blank menu
	/* ------------------------------------------------------------------ */
	
	function blank($title = "Login")
	{
		// Remove all other menus
		$this->remove_all();

		// Make custom menu
		//$this->add($title, "");
	}


	/* ------------------------------------------------------------------ */
	//	Check if any menu available
	/* ------------------------------------------------------------------ */
	
	function available()
	{
		return (!empty($this->MenuData));
	}
}


/* ------------------------------------------------------------------ */
//	EP-Dev Whois Admin Error Handle Class
//	Contains all error output related functions.
/* ------------------------------------------------------------------ */

class EP_Dev_Whois_Admin_Error_Handle extends mosHTML 
{
	/* ------------------------------------------------------------------ */
	//	Stop with $code
	//  Dies with error ouput
	/* ------------------------------------------------------------------ */

	function stop($code)
	{
		$this->kill($this->go($code));
	}


	/* ------------------------------------------------------------------ */
	//	Go $code
	//  Returns textual error based on $code
	/* ------------------------------------------------------------------ */
	
	function go($code, $extra = NULL)
	{
		switch ($code)
		{
			case "mysql_connect_error" : 
				$return = "Error connecting to mysql database with username and password specified.";
			break;

			case "mysql_db_error" : 
				$return = "Error connecting to specified database name.";
			break;

			case "invalid_number" : 
				$return = "ERROR: Invalid number specified for " . $extra;
			break;

			case "invalid_bool" : 
				$return = "ERROR: Invalid value specified for " . $extra;
			break;

			case "bad_permissions" : 
				$return = "ERROR: Could not open or write to file the new settings. Check file permissions section of trouble shooting.";
			break;

			case "bad_login" :
				$return = "Please enter correct username and password!";
			break;

			case "panel_disabled" :
				$return = "The administration panel has been disabled from within the configuration file.";
			break;

			case "nameserver_exists" :
				$return = "The nameserver specified already exists! Please use the edit nameservers task to modify it.";
			break;

			case "bad_nameserver" :
				$return = "You did not specify an address for this nameserver.";
			break;

			default : $return = "An unknown error occurred!";
		}

		return $return;
	}


	/* ------------------------------------------------------------------ */
	//	Kill with $error
	//  dies with textual $error
	/* ------------------------------------------------------------------ */
	
	function kill($error)
	{
		// new display obj
		$display = new jf_admin_display("ERROR");

		// display task
		$display->displaytask($error, "ERROR -- " . $error);

		die();
	}
}